config/routes.rb
Rails.application.routes.draw do
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
  root 'doctors#index'
  #resources :doctors, only:[:index, :show]
  resources :doctors do
    member do
      get :delete
    end
  end

  resources :patients
  # do
  #   member do
  #     get :delete
  #   end
  # end
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/doctor.rb
class Doctor < ApplicationRecord
  scope :available_doctors, -> { where(availability: true) }
  scope :unavailable_doctors, -> { where(availability: false) }

  validates :name ,presence: true
  validates :experience ,presence: true
  validates :fee ,presence: true
end

app/models/patient.rb
class Patient < ApplicationRecord
  validates :name ,presence: true
  validates :gender ,presence:false
  validates :email ,presence: true
  validates :age ,presence: false
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/doctors_controller.rb
class DoctorsController < ApplicationController
  def index
    @doctors = Doctor.all
  end

  def show
    @doctors = Doctor.find(params[:id])
  end

  def new
    @doctor = Doctor.new
  end

  def create
    @doctor= Doctor.new(doctor_params)
    if @doctor.save
      redirect_to doctors_path
    else
      render 'new'
    end
  end

  def edit
    @doctor = Doctor.find(params[:id])
  end

  def update
    @doctor = Doctor.find(params[:id])
    if @doctor.update(doctor_params)
      redirect_to doctor_path @doctor
    else
      render 'edit'
    end
  end

  def destroy
    @doctor = Doctor.find(params[:id])
    @doctor.destroy
    redirect_to doctors_path
  end

  private
  def doctor_params
    params.required(:doctor).permit(:name, :experience, :fee, :availability)
  end

end

app/controllers/patients_controller.rb
class PatientsController < ApplicationController

  def index
    @patients = Patient.all
  end

  def show
    @patients = Patient.find(params[:id])
  end

  def new
    @patient = Patient.new
  end

  def create
    @patient= Patient.new(patient_params)
    if @patient.save
      redirect_to patients_path
    else
      render 'new'
    end
  end

  def edit
    @patient = Patient.find(params[:id])
  end

  def update
    @patient = Patient.find(params[:id])
    if @patient.update(patient_params)
      redirect_to patient_path @patient
    else
      render 'edit'
    end
  end

  def destroy
    @patient = Patient.find(params[:id])
    @patient.destroy
    redirect_to patients_path
  end

  private
  def patient_params
    params.required(:patient).permit(:name, :gender, :email, :age)
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/doctors_helper.rb
module DoctorsHelper
end

app/helpers/patients_helper.rb
module PatientsHelper
end

app/views/doctors/edit.html.erb
<h1>Edit Doctor</h1>
<%= form_for :doctor, url: doctor_path(@doctor), method: :patch do |f| %>
  <% if @doctor.errors.any? %>
    <% @doctor.errors.full_messages.each do |msg| %>
      <div class="alert alert-danger"><%= msg %></div>
      <% end %>
  <% end %>
  <p>
    <%= f.label :name %> <br>
    <%= f.text_field(:name, {:class => 'form-control'}) %>
  </p>

  <p>
    <%= f.label :experience %> <br>
    <%= f.text_field(:experience, {:class => 'form-control'}) %>
  </p>

  <p>
    <%= f.label :fee %> <br>
    <%= f.text_field(:fee, {:class => 'form-control'}) %>
  </p>

  <p>
    <%= f.label :availability %> <br>
    <%= f.text_field(:availability, {:class => 'form-control'}) %>
  </p>
  <p>
    <%= f.submit("Edit Doctor",{:class => 'btn btn-primary'}) %>
  </p>
<% end %>

app/views/doctors/index.html.erb
<h1>Doctor</h1>
<%= link_to "Create Doctor", new_doctor_path%>
<% @doctors.each do |doctor| %>
  <div class="well">
    <h3><%= doctor.name %></h3>
    <p><%= doctor.experience %></p>
    <p><%= doctor.fee %></p>
    <%= link_to "Show", doctor_path(doctor.id), :class => 'btn btn-defualt' %>
    <%= link_to "Edit", edit_doctor_path(doctor.id), :class => 'btn btn-defualt' %>
    <%= link_to 'Delete', doctor_path(doctor.id),
                        method: :delete,
                        data: {confirm: 'Are you sure?'},
                        :class => 'btn btn-danger' %>
  </div>
<% end %>

app/views/doctors/new.html.erb
<h1>Add Doctor</h1>
<%= form_for :doctor, url: doctors_path  do |f| %>
  <% if @doctor.errors.any? %>
    <% @doctor.errors.full_messages.each do |msg| %>
      <div class="alert alert-danger"><%= msg %></div>
      <% end %>
  <% end %>
  <p>
    <%= f.label :name %> <br>
    <%= f.text_field(:name, {:class => 'form-control'}) %>
  </p>

  <p>
    <%= f.label :experience %> <br>
    <%= f.text_area(:experience, {:class => 'form-control'}) %>
  </p>

  <p>
    <%= f.label :fee %> <br>
    <%= f.text_area(:fee, {:class => 'form-control'}) %>
  </p>

  <p>
    <%= f.label :availability %> <br>
    <%= f.text_area(:availability, {:class => 'form-control'}) %>
  </p>
  <p>
    <%= f.submit("Create Doctor",{:class => 'btn btn-primary'}) %>
  </p>
<% end %>

app/views/doctors/show.html.erb
<h1>Show Doctor</h1>
<h3><%= @doctors.name %></h3>
<p><%= @doctors.experience %></p>
<p><%= @doctors.fee %></p>
<p><%= @doctors.availability ? 'Yes' : 'No' %></p>
<p><%= @doctors.created_at %></p>
<p><%= @doctors.updated_at %></p>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Hospital</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <ul class="btn btn-defualt">

    </ul>
    <%= yield %>
  </body>
</html>

app/views/patients/edit.html.erb
<h1>Edit Patient</h1>
<%= form_for :patient, url: patient_path(@patient), method: :patch do |f| %>
  <% if @patient.errors.any? %>
    <% @patient.errors.full_messages.each do |msg| %>
      <div class="alert alert-danger"><%= msg %></div>
      <% end %>
  <% end %>
  <p>
    <%= f.label :name %> <br>
    <%= f.text_field(:name, {:class => 'form-control'}) %>
  </p>

  <p>
    <%= f.label :gender %> <br>
    <%= f.text_area(:gender, {:class => 'form-control'}) %>
  </p>

  <p>
    <%= f.label :email %> <br>
    <%= f.text_area(:email, {:class => 'form-control'}) %>
  </p>

  <p>
    <%= f.label :age %> <br>
    <%= f.text_area(:age, {:class => 'form-control'}) %>
  </p>
  <p>
    <%= f.submit("Edit Patient",{:class => 'btn btn-primary'}) %>
  </p>
<% end %>

app/views/patients/index.html.erb
<h1>Patient</h1>
<%= link_to "Create Patient", new_patient_path%>
<% @patients.each do |patient| %>
  <div class="well">
    <h3><%= patient.name %></h3>
    <p><%= patient.gender %></p>
    <p><%= patient.email %></p>
    <p><%= patient.age %></p>
    <%= link_to "Show", patient_path(patient.id), :class => 'btn btn-defualt' %>
    <%= link_to "Edit", edit_patient_path(patient.id), :class => 'btn btn-defualt' %>
    <%= link_to 'Delete', patient_path(patient.id),
                        method: :delete,
                        data: {confirm: 'Are you sure?'},
                        :class => 'btn btn-danger' %>
  </div>
<% end %>

app/views/patients/new.html.erb
<h1>Add Patient</h1>
<%= form_for :patient, url: patients_path  do |f| %>
  <% if @patient.errors.any? %>
    <% @patient.errors.full_messages.each do |msg| %>
      <div class="alert alert-danger"><%= msg %></div>
      <% end %>
  <% end %>
  <p>
    <%= f.label :name %> <br>
    <%= f.text_field(:name, {:class => 'form-control'}) %>
  </p>

  <p>
    <%= f.label :gender %> <br>
    <%= f.text_field(:gender, {:class => 'form-control'}) %>
  </p>

  <p>
    <%= f.label :email %> <br>
    <%= f.text_field(:email, {:class => 'form-control'}) %>
  </p>

  <p>
    <%= f.label :age %> <br>
    <%= f.text_field(:age, {:class => 'form-control'}) %>
  </p>
  <p>
    <%= f.submit("Create Patient",{:class => 'btn btn-primary'}) %>
  </p>
<% end %>

app/views/patients/show.html.erb
<h1>Show Patient</h1>
<h3><%= @patients.name %></h3>
<p><%= @patients.gender %></p>
<p><%= @patients.email %></p>
<p><%= @patients.age %></p>
<p><%= @patients.created_at %></p>
<p><%= @patients.updated_at %></p>